<?php

/**
 * co_docum_modalidad actions.
 *
 * @package    contratacion
 * @subpackage co_docum_modalidad
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_docum_modalidadActions extends sfQuery
{
    
    
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_DOCUM_MODALIDAD','CO_TIPO_DOCUMENTO','CO_MODALIDAD_SEL'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_MODALIDAD_SEL' =>
         array (
            'id_modalidad_sel' => 'CO_DOCUM_MODALIDAD'
         ),
        'CO_TIPO_DOCUMENTO'=>
        array(
            'id_tipo_documento'=>'CO_DOCUM_MODALIDAD'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_DOCUM_MODALIDAD' =>
       array(
            'id_docum_modalidad' => 'id_docum_modalidad',
            'id_tipo_documento' => 'id_tipo_documento',
            'id_modalidad_sel' => 'id_modalidad_sel',
            'estado' => 'estado',
            'opcional' => 'opcional'
        ),
        'CO_MODALIDAD_SEL'=>
        array(
            'prefijo' => 'prefijo_modalidad',
            'descripcion' => 'descripcion_modalidad'
        ),
        'CO_TIPO_DOCUMENTO'=>
        array(
            'descripcion' => 'descripcion_tipodocumento'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_DOCUM_MODALIDAD' =>
        array(    
            'id_docum_modalidad,a' => array('!=' => array(-1)),
            'id_docum_modalidad,b' => array('=' => array('id_docum_modalidad')),
            'id_tipo_documento' => array('=' => array('id_tipo_documento')),
            'id_modalidad_sel' => array('=' => array('id_modalidad_sel')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_MODALIDAD_SEL'=>
        array(
            'prefijo,a' => array('LIKEALLPLUS' => array('prefijo_modalidad', '%')),
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion_modalidad', '%'))
        ),
        'CO_TIPO_DOCUMENTO'=>
        array(
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion_tipodocumento', '%'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_docum_modalidad'; //identificador de la tabla
    protected $id_names = array('id_docum_modalidad'); //llave primaria
    protected $field_names = array('id_tipo_documento', 'id_modalidad_sel','estado','opcional'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_DOCUM_MODALIDAD'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_docum_modalidad'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        $id_tipo_documento = $request['id_tipo_documento'];
        $id_modalidad_sel = $request['id_modalidad_sel'];
        
        $sql = <<<EOD
        select count(*) as cantidad from co_docum_modalidad tab0
                where id_tipo_documento = $id_tipo_documento and id_modalidad_sel = $id_modalidad_sel
EOD;
        $records = CN_TABLE::executeSQL($sql);
        
        
        /*
         *  Validar la operación, ya sea por SQL
         */

        $cantidad = $records[0]['cantidad'];
        
        if($cantidad>0){
            $errors['mensaje'] = "Ya ha registrado este documento para la Modalidad";
            $errors['servicio'] = "co_docum_modalidad";
        }
        
        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_docum_modalidad = $request['id_docum_modalidad'];
        
        $sql = <<<EOD
        select count(*) as cantidad from co_documento_ep tab0
                where id_docum_modalidad = $id_docum_modalidad 
EOD;
        $records = CN_TABLE::executeSQL($sql);
        
        $cantidad = $records[0]['cantidad'];

        /*
         *  Generar errores en $errors
         */
        if($cantidad>0){
            $errors['mensaje'] = "No se puede eliminar, Existen estudios previos con este documento asociado.";
            $errors['servicio'] = "co_docum_modalidad";
        }

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
}
